'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var styled = _interopDefault(require('@emotion/styled'));
var core = require('@emotion/core');

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

function _templateObject3() {
  var data = _taggedTemplateLiteralLoose(["\n      position: absolute;\n      padding: 4px 11px;\n      left: 0;\n      top: 0;\n      height: 19.2px;\n      box-shadow: 0 2px 6px 2px rgba(60, 64, 67, 0.15);\n      background: #fff;\n      z-index: 999;\n      .sizer {\n        display: contents;\n      }\n    "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteralLoose(["\n  ", "\n  display: inline-block;\n  input {\n    width: 100%;\n    font-family: inherit;\n    font-size: inherit;\n    padding: 0;\n    border: none;\n    outline: none;\n  }\n  .sizer {\n    height: 0;\n    overflow: scroll;\n    visibility: hidden;\n    white-space: pre;\n    position: absolute;\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n  border: 1px solid #d9d9d9;\n  border-radius: 2px;\n  margin: 0 8px 8px 0;\n  padding: 4px 11px;\n  font-size: inherit;\n  min-height: 19.2px;\n  position: relative;\n  width: ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var InputContainer = /*#__PURE__*/styled.div( /*#__PURE__*/_templateObject(), function (props) {
  return props.fixedWidth + "px";
});
var OverflowContainer = /*#__PURE__*/styled.div( /*#__PURE__*/_templateObject2(), function (props) {
  return props.isOverflow && core.css(_templateObject3());
});

var OverflowInput = function OverflowInput(props) {
  var readOnly = props.readOnly,
      required = props.required,
      disabled = props.disabled,
      invalid = props.invalid,
      rest = _objectWithoutPropertiesLoose(props, ["readOnly", "required", "disabled", "invalid"]);

  var inputRef = React.useRef(null);
  var parentRef = React.useRef(null);
  var sizerRef = React.useRef(null);

  var _useState = React.useState(false),
      overflow = _useState[0],
      setOverflow = _useState[1];

  var sizerValue = [props.defaultValue, props.value, ''].reduce(function (previousValue, currentValue) {
    if (previousValue !== null && previousValue !== undefined) {
      return previousValue;
    }

    return currentValue;
  });
  React.useEffect(function () {
    checkOverflow();
  }, [props.value]);

  var checkOverflow = function checkOverflow() {
    if (overflow) {
      var _inputRef$current, _parentRef$current;

      if ((((_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 ? void 0 : _inputRef$current.clientWidth) || 0) <= (((_parentRef$current = parentRef.current) === null || _parentRef$current === void 0 ? void 0 : _parentRef$current.clientWidth) || 0)) {
        setOverflow(false);
      }
    } else {
      var _inputRef$current2, _inputRef$current3;

      if ((((_inputRef$current2 = inputRef.current) === null || _inputRef$current2 === void 0 ? void 0 : _inputRef$current2.scrollWidth) || 0) > (((_inputRef$current3 = inputRef.current) === null || _inputRef$current3 === void 0 ? void 0 : _inputRef$current3.clientWidth) || 0)) {
        setOverflow(true);
      }
    }
  };

  return React__default.createElement(InputContainer, {
    ref: parentRef,
    fixedWidth: 50
  }, React__default.createElement(OverflowContainer, {
    isOverflow: overflow
  }, React__default.createElement("input", Object.assign({
    ref: inputRef,
    "aria-readonly": readOnly,
    "aria-required": required,
    "aria-disabled": disabled,
    "aria-invalid": invalid,
    required: required,
    disabled: disabled,
    readOnly: readOnly
  }, rest, {
    onBlur: function onBlur() {
      setOverflow(false);
    },
    onFocus: function onFocus() {
      checkOverflow();
    }
  })), React__default.createElement("div", {
    className: "sizer",
    ref: sizerRef
  }, sizerValue)));
};

exports.default = OverflowInput;
//# sourceMappingURL=react-input-overflow.cjs.development.js.map
